/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelEncryption = {};
panelEncryption.localization = {};
/****************************/

// Panel details
var panelName = "Encryption";
var _panel = $("#pnl" + panelName);

// Localizations
panelEncryption.localization = {
	headerText : "",
	lblPasswordTabText : "Password",
	lblSSLTabText : "SSL",
	lblFilesTabText : "Files",
	lblPasswordTypeDESText : "DES",
	lblPasswordTypeDESDescText : " (If you have users that often want you to lookup their password, use this option.) ",
	lblPasswordTypeSHAText : "SHA",
	lblPasswordTypeMD5Text : "MD5",
	lblPasswordTypeSHAMD5DescText : " (If you never want a password to be reversible, and want added security, use this option.) ",
	lblFormAllowUseOfBlankPasswordText : " Allow users with blank passwords to login.",
	lblNumberOfCharactersForRandomPasswordText : "Number of characters for random passwords :",
	lblNewPasswordMinimumLengthText : "New password minimum length :",
	lblMinimumNumericCharsText : "Minimum numeric characters :",
	lblMinimumLowerCaseCharsText : "Minimum lower case characters :",
	lblMinimumUpperCaseCharsText : "Minimum upper case characters :",
	lblMinimumSpecialCharsText : "Minimum special characters :",
	lblPasswordHistoryCountText : "Password history count :",
	lblSSLTabNoteText : "This is a SSL certificate. It is used for HTTPS connections and FTPS. ",
	btnGenerateSelfSignedCertiText : " Generate Self Signed Certificate ",
	lblKeystoreLocationText : "Keystore Location :",
	btnKeyStoreLocationBrowseText : "Browse ",
	lblKeystorePasswordText : "Keystore Password :",
	btnKeyStorePasswordTestCertificateText : "Test Certificate ",
	lblKeyPasswordText : "Key Password :",
	lblFormRequireValidClientCertificateText : " Require valid client certificate.",
	btnApplyToWebInterfacesCrushUploaderText : "Apply to WebInterface's CrushUploader ",
	lblDisabledCiphersText : " Disabled Ciphers (Generally keep all ciphers enabled) ",
	lblEncryptFilesText : " Encrypt Files",
	lblPGPKeyText : "Public PGP Key : ",
	lblDecryptFilesText : " Decrypt Files",
	lblPrivatePGPKeyText : "Private PGP Key : ",
	lblPrivatePGPKeyPassText : "Private PGP Key Pass : ",
	btnGenerateEncryptionKeyText : "Generate Encryption Key",
	lblPGPKeyOldText : "Key Location : ",
	lblKeyLocationText : "Key Location :",
	btnKeyStoreLocationBrowseText : "Browse ",
	pnlFilesHelpText : "<p> File based encryption allows you to store files on your drive in an encrypted format. These files will be unusable to anything outside of CrushFTP, and with the right key. This encryption however provides security in that if the physical files are compromised, they will be useless to whoever has gotten them. </p> <p> lf any of the below warnings do not make sense, or you do not understand them fully, <br> <strong>I highly recommend you do not use this feature</strong> <br> as you can potentially turn many files into unrecoverable encrypted files! <br> </p> <p> <strong>Caution</strong> should be taken in guarding the keyfile. Placing it on a network location is the ideal solution. </p> <p> <strong>WARNING:</strong> Changing the keyfile once files have been encrypted will cause the files to be unrecoverable. You must transfer all files that are encrypted through CrushFTP to another location so that they are not encrypted. At this point you can change the key file, and transfer the files back through CrushFTP to re-encrypt them using the new keyfile. </p> ",
	btnGenerateEncryptionKeyText : "Generate Key",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelEncryption.localization, localizations.panels[panelName]);

// Interface methods
panelEncryption.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelEncryption.localization.Header, true);
	panelEncryption.bindData();
	panelEncryption.bindEvents();
}

panelEncryption.defaultPopupData = {
	keystorepath : "",
	alias : "mykey",
	days : "365",
	bits : "1024",
	common_name : "www.domain.com",
	city : "no_city",
	state : "no_state",
	country : "US",
	organization : "Customer",
	organizational_unit : "Client",
	password1 : "",
	password2 : ""
};

panelEncryption.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	if($("#fileEncryptionKey").val()!="")
	{
		$(".oldEncryption", _panel).show();
	}
	else
	{
		$(".oldEncryption", _panel).hide();
	}
	checkUnchekInput($("#password_encryption_" + getTextValueFromXMLNode(prefs.password_encryption, ""), _panel), true);

	var serverInfo = $(document).data("server_info");
	if(serverInfo && serverInfo["ciphers"])
	{
		var ciphers = serverInfo["ciphers"];
		if(ciphers && ciphers.length>0)
		{
			var nameList = $("#disabled_ciphers", _panel).empty();
			ciphers = ciphers.split(",");
			for(var i=0;i<ciphers.length;i++)
			{
				var curItem = ciphers[i];
				if(curItem)
				{
					var newControl = $("<div><input type=\"checkbox\" class=\"excludeXML\" id=\"dc_"+curItem+"\" /><label for=\"dc_"+curItem+"\">"+curItem+"</label></div>");
					nameList.append(newControl);
				}
			}
		}
	}

	var disabled_ciphers = getTextValueFromXMLNode(prefs.disabled_ciphers, "");
	disabled_ciphers = disabled_ciphers.split(")");
	var disabled_ciphers_list = $("#disabled_ciphers", _panel);
	for(var item in disabled_ciphers)
	{
		var curItem = disabled_ciphers[item];
		if(curItem.length>0 && curItem.substr)
		{
			curItem = curItem.substr(1, curItem.length);
			if(curItem && curItem.length>0)
			{
				checkUnchekInput(disabled_ciphers_list.find("input#dc_"+curItem), true);
			}
		}
	}
}

panelEncryption.bindEvents = function()
{
	$("a#selectAllCiphers, a#deselectAllCiphers", _panel).click(function(){
		var flag= $(this).is("#selectAllCiphers");
		checkUnchekInput($("#disabled_ciphers", _panel).find("input"), flag);
		itemsChanged(true);
		return false;
	});

	$("a.serverFilePickButton", _panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'file',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel")).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	 $("#generateCertiPopup", _panel).form().dialog({
		autoOpen: false,
		height: 590,
		width: 600,
		title : "Generate Self Signed Certificate",
		modal: true,
		resizable: false,
		closeOnEscape: false,
		buttons: {
			"Cancel" : function(){
				$(this).dialog( "close" );
			},
			"Ok": function() {
				var pass1 = $("#generateCertiPopup").find("#password1").val();
				var pass2 = $("#generateCertiPopup").find("#password2").val();
				if(pass1 != pass2)
				{
					jAlert("Password does not match the confirm password", "Error", function(){
						$("#generateCertiPopup").find("#password2").focus().select();
					});
					return false;
				}
				var params = {command : "generateSSL"};
				$("#generateCertiPopup").find("input").each(function(){
					params[$(this).attr("id")] = $(this).val();
				});
				$("#generateCertiPopup").parent().block({
					message:  '<span><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>Wait..</span>',
					css: {
						border: 'none',
						padding: '5px',
						backgroundColor: '#000',
						'-webkit-border-radius': '10px',
						'-moz-border-radius': '10px',
						opacity: .5,
						color: '#fff',
						'text-align':'center'
					}
				});
				common.data.serverRequest(params, function(msg){
					$("#generateCertiPopup").parent().unblock();
					growl("Generating Certificate", decodeURIComponent($(msg).text()), false, false);
					$(this).dialog("close");
				});
			}
		},
		open: function(){
			$("#generateCertiPopup").find("input").each(function(){
				var curVal = panelEncryption.defaultPopupData[$(this).attr("id")] || "";
				$(this).val(curVal);
			});
		}
	});

	$("a#generateSelfSignedCerti", _panel).click(function(){
		$("#generateCertiPopup").dialog("open");
		return false;
	});

	$("a#testCertificate", _panel).click(function(){
		if($(this).attr("disabled"))return false;
		var obj = {
			command : "testKeystore",
			keystorePath : common.methods.htmlEncode($("#cert_path", _panel).val()),
			keystorePass : common.methods.htmlEncode($("#globalKeystorePass", _panel).val()),
			keyPass : common.methods.htmlEncode($("#globalKeystoreCertPass", _panel).val())
		};
		$("a#testCertificate", _panel).block({
			message:  'Wait..',
			css: {
				border: 'none',
				padding: '0px 10px',
				backgroundColor: '#000',
				'-webkit-border-radius': '10px',
				'-moz-border-radius': '10px',
				opacity: .5,
				color: '#fff',
				'text-align':'left'
			}
		}).attr("disabled", "disabled");

		common.data.serverRequest(obj, function(msg){
			$("a#testCertificate", _panel).unblock().removeAttr("disabled");
			growl("Testing Certificate", decodeURIComponent($(msg).text()), false, false);
		});
		return false;
	});

	/*$("a#buildFileKey", _panel).click(function(){
		if($(this).attr("disabled"))return false;
		var obj = {
			command : "generateFileKey",
			keyPath : $("#fileEncryptionKey", _panel).val()
		};
		$("a#buildFileKey", _panel).block({
			message:  'Wait..',
			css: {
				border: 'none',
				padding: '0px 10px',
				backgroundColor: '#000',
				'-webkit-border-radius': '10px',
				'-moz-border-radius': '10px',
				opacity: .5,
				color: '#fff',
				'text-align':'left'
			}
		}).attr("disabled", "disabled");

		common.data.serverRequest(obj, function(msg){
			$("a#buildFileKey", _panel).unblock().removeAttr("disabled");
			growl("Generating file key", decodeURIComponent($(msg).text()), false, false);
		});
		return false;
	});*/

	$("#pgpEncryptionGenerateButton", _panel).unbind().click(function () {
		if ($("#pgpPivateKeyPathGenerate", _panel).val().indexOf(".key") < 0)
		{
			$("#pgpPivateKeyPathGenerate", _panel).val($("#pgpPivateKeyPathGenerate", _panel).val()+"private.key");
		}
		var obj = {
			command: "pgpGenerateKeyPair",
			pgpCommonNameGenerate: common.methods.htmlEncode($("#pgpCommonNameGenerate", _panel).val()),
			pgpKeySizeGenerate: $("#pgpKeySizeGenerate", _panel).val(),
			pgpKeyDaysGenerate: $("#pgpKeyDaysGenerate", _panel).val(),
			pgpPrivateKeyPasswordGenerate: common.methods.htmlEncode($("#pgpPrivateKeyPasswordGenerate", _panel).val()),
			pgpPivateKeyPathGenerate: common.methods.htmlEncode($("#pgpPivateKeyPathGenerate", _panel).val()),
			random: Math.random()
		};
		$.ajax({
			type: "POST",
			url: window.ajaxCallURL,
			data: obj,
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				errorThrown = errorThrown || "pgpGenerateKeyPair failed";
				growl("Error : ", errorThrown, true, true);
			},
			success: function (msg) {
				var responseText = msg;
				try {
					var response = msg.getElementsByTagName("response");
					response = common.data.getTextContent(response[0]).textContent;
					alert(response);
					if(response.toLowerCase()=="success")
						$("#generateKeyPanel", _panel).find("input").val("");
				} catch (ex) {}
			}
		});
		return false;
	});

	$("#removeOldEncryptionMethod", _panel).unbind().click(function(){
		$("#fileEncryptionKey", _panel).val("").trigger("change");
		if($("#fileEncryptionKey", _panel).val()!="")
		{
			$(".oldEncryption", _panel).show();
		}
		else
		{
			$(".oldEncryption", _panel).hide();
		}
		return false;
	});
}

panelEncryption.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var xmlData = '<server_prefs type="properties">'+panelEncryption.buildXMLData(_panel)+'</server_prefs>';
		common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", xmlData, function(data){
			data = $.xml2json(data, true);
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				common.data.updateLocalPrefs(function(){
					common.UI.hideIndicator();
					growl("Data saved", "Your changes are saved", false, 5000);
					placeHolder.removeData("hasChanged");
				});
			}
			else
			{
				growl("Error while saving", "Your changes are not saved", true);
			}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}

panelEncryption.buildXMLData = function()
{
	var xmlString = buildXMLToSubmitForm(_panel);
	var password_encryption = "";
	$("input.encryptionType:checked", _panel.find("#EncryptionPassword")).each(function(){
		password_encryption += $(this).attr("id").replace("password_encryption_","").toUpperCase();
	});
	xmlString += "\r\n<password_encryption>" + password_encryption + "</password_encryption>";

	var disabled_ciphers = "";
	$("input:checked", _panel.find("#disabled_ciphers")).each(function(){
		disabled_ciphers += "(" + $(this).attr("id").replace("dc_", "") + ")";
	});
	xmlString += "\r\n<disabled_ciphers>" + disabled_ciphers + "</disabled_ciphers>";
	return xmlString;
}