/*!
* CrushFTP DND integration in WebInterface
*
* http://crushFTP.com/
*
* Copyright 2012, CrushFTP
*
* Date: Tue, Apr 17 2012
*
* Author: Vipul Limbachiya
*
* http://vipullimbachiya.com
*/
$(function () {
    'use strict';
	 if (!$.CrushFTP) {
        $.CrushFTP = new Object();
    };

	var is_MacOs = navigator.userAgent.indexOf('Mac') > -1;
	$.CrushFTP.maxFileSizeAllowedInNormalUploadInMB = 500;
	$.CrushFTP.browserSupportsDND = function()
	{
		var flag = false;
		var is_chrome = navigator.userAgent.indexOf('Chrome') > -1;
		var is_explorer = navigator.userAgent.indexOf('MSIE') > -1;
		var is_firefox = navigator.userAgent.indexOf('Firefox') > -1;
		var is_safari = navigator.userAgent.indexOf("Safari") > -1;
		var is_Opera = navigator.userAgent.indexOf("Presto") > -1;

		if ((is_chrome)&&(is_safari)) {is_safari=false;}

		if(is_chrome)
		{
			flag = true;
		}
		else if(is_safari && is_MacOs)
		{
			/*var ua = navigator.userAgent.substring(navigator.userAgent.indexOf('safari/') +7);
			ua = ua.substring(0, ua.indexOf('.'));
			var version = ua;
			if(version && parseInt(version))
			{
				if(parseInt(version)>=5)
					flag = true;
			}*/
			flag = true;
		}
		else if(is_firefox)
		{
			var ua = navigator.userAgent;
			var version = /Firefox\/([0-9\.A-z]+)/.exec(ua)[1];
			if(version && parseInt(version))
			{
				if(parseInt(version)>3.5)
					flag = true;
			}
		}
		/*else if(is_Opera)
		{
			var version = $.browser.version;
			if(version && parseInt(version))
			{
				if(parseInt(version)>=11)
					flag = true;
			}
		}*/
		return flag;
	}

	$.CrushFTP.formatBytes = function(bytes) {
		if(!bytes) return "-";
		else if ((bytes / 1024).toFixed(0) == 0) return bytes + " bytes";
		else if ((bytes / 1024 / 1024).toFixed(0) == 0) return (bytes / 1024).toFixed(1) + " KB";
		else if ((bytes / 1024 / 1024 / 1024).toFixed(0) == 0) return (bytes / 1024 / 1024).toFixed(1) + " MB";
		else if ((bytes / 1024 / 1024 / 1024 / 1024).toFixed(0) == 0) return (bytes / 1024 / 1024 / 1024).toFixed(1) + " GB";
		else if ((bytes / 1024 / 1024 / 1024 / 1024 / 1024).toFixed(0) == 0) return (bytes / 1024 / 1024 / 1024 / 1024).toFixed(1) + " TB";
	}

	var IsNumeric = function(input) {
		return !((input - 0) == input && input.length > 0);
	}

	$.CrushFTP.formatTime = function(secs) {
		var remaining = "";
		secs = secs.substring(0, secs.indexOf(".")) * 1;
		var mins = (secs / 60) + ".0";
		mins = mins.substring(0, mins.indexOf(".")) * 1;
		if (mins > 0) {
			secs -= (mins * 60);
			remaining = mins + " min, " + secs + " secs";
		} else {
			if (secs < 0) {
				remaining = getLocalizationKeyExternal("BrowserUploaderSpeedTimeCalculatingText");
			} else {
				remaining = secs + " secs";
			}
		}
		return remaining;
	}

	$.CrushFTP.formatFileSize = function (bytes) {
		return $.CrushFTP.formatBytes(bytes);
	}

	var fileRepo = $("#fileRepo");
	var fileQueueInfo = $("#fileQueueInfo");
	var browseFileButtonPanel = $("#browseFileButtonPanel");
	var AdvancedBrowseResumeOption = $('#AdvancedBrowseResumeOption');
	var javaAppletDiv = $("#javaAppletDiv");
	var overwriteAllLinkBtn = fileRepo.find("#overwriteAllLinkBtn");
	var clearUploadedAll = fileRepo.find("a.uploadedAll");
	var remvoeErrorAllLinkBtn = fileRepo.find("#remvoeErrorAllLinkBtn");
	var totalFilesText = fileRepo.find("span.totalFiles");
	var totalSizeText = fileRepo.find("span.totalSize");
	var viewFileQueue = fileQueueInfo.find("#viewFileQueue");
	var globalProgressBar = $("#globalProgressBar");
	var refreshBtn = $("#mainContent").find("span.refreshButton");

	if(!$.CrushFTP.browserSupportsDND())
	{
		totalSizeText.prev().remove();
		totalSizeText.remove();
	}

	$.CrushFTP.buildQueueInfo = function(){
		var itemsSelected = fileRepo.find("li");
		if(itemsSelected && itemsSelected.length>0)
		{
			var totalSize = 0;
			itemsSelected.each(function(){
				if($(this).find(".noCount").length==0)
					totalSize += parseInt($(this).attr("size"));
			});
			totalFilesText.text(itemsSelected.length);
			totalSizeText.text($.CrushFTP.formatBytes(totalSize));
			fileRepo.show().trigger("visibilityChange").data("totalSize", totalSize);
			viewFileQueue.show();
		}
		else
		{
			totalFilesText.text("");
			totalSizeText.text("");
			fileRepo.hide();
			fileRepo.trigger("visibilityChange");
			viewFileQueue.hide();
		}
		$.CrushFTP.bindUploadItemEvents();
		if(fileRepo.find("ul").find("a.overwriteLink:visible").length>0)
			overwriteAllLinkBtn.show();
		else
			overwriteAllLinkBtn.hide();

		if(fileRepo.find("li.uploaded").length>0)
			clearUploadedAll.show();
		else
			clearUploadedAll.hide();

		if(fileRepo.find("ul").find("li.hasError").length>0)
			remvoeErrorAllLinkBtn.show();
		else
			remvoeErrorAllLinkBtn.hide();

		if($.CrushFTP.UploadProgressing && $.CrushFTP.uploadAllQueued)
			$.CrushFTP.getNextQueuedItem();
	};

	var getFileExtension = function(filename) {
		var ext = /^.+\.([^.]+)$/.exec(filename);
		return ext == null ? "" : ext[1].toLowerCase();
	}

	$.CrushFTP.showIconsForFiles = function()
	{
		fileRepo.find("li:not(.appletItem)").each(function(){
			var item = $(this);
			if(item.hasClass("iconSet"))return;
			item.addClass("iconSet");
			var ext = getFileExtension(item.find("div.name").text());
			if(ext == "jpg" || ext == "jpeg" || ext == "gif" || ext == "png" || ext == "bmp")
				return;
			var imgSrc = "";
			if ($.CrushFTP.Options.availableFileExtensionImages.has(ext)) {
				imgSrc = $.CrushFTP.Options.FileExtensionImageFilePath + ext + "_32.png";
			} else {
				imgSrc = $.CrushFTP.Options.fileLarge + "_32.png";
			}
			if(imgSrc.length>0)
				item.find("div.preview").find("span.fade").empty().append("<img style='margin-top:5px;' src='"+imgSrc+"'/>");
		});
	};

	$.CrushFTP.bindUploadEvents = function() {
		overwriteAllLinkBtn.unbind().bind("click", function(){
			fileRepo.find("ul").find("a.overwriteLink").trigger("click");
			$(this).hide();
			return false;
		});

		remvoeErrorAllLinkBtn.unbind().bind("click", function(){
			fileRepo.find("li.hasError").find("a.cancelUpload").trigger("click");
			$(this).hide();
			return false;
		});

		viewFileQueue.unbind().click(function(){
			var cluetipTitle = $("#cluetip-title");
			if($(this).hasClass("close"))
			{
				fileRepo.slideUp("fast");
				$(this).removeClass("close");
			}
			else
			{
				fileRepo.slideDown("fast");
				$(this).addClass("close");
			}
			$(this).blur();
			return false;
		}).hide();

		fileRepo.find("#toggleFileList").click(function(){
			viewFileQueue.trigger("click");
		});

		fileRepo.find("a.cancelUploading").unbind().click(function(){
			if($(this).hasClass("uploadedAll"))
			{
				fileRepo.find("li.uploaded").find("a.cancelUpload").trigger("click");
			}
			else
				$(fileRepo.find("li").get().reverse()).each(function(){
					$(this).find("a.cancelUpload").trigger("click");
				});
			return false;
		});

		fileRepo.find("a.startUploading").unbind().click(function(){
			var startBtn = $.CrushFTP.getNextQueuedItem();
			if(startBtn)
				startBtn.trigger("click", [{allInQueue:true}]);
			return false;
		});

	}

	$.CrushFTP.getNextQueuedItem = function(notBatchUpload) {
		var startBtn = false;
		var hasBtns = false;
		if(!notBatchUpload)
		{
			fileRepo.find("li:not(.uploaded, .error, .skipped, .ui-state-highlight, .hasError, .warning)").each(function(){
				var startUploadBtn = $(this).find("a.startUpload");
				if(startUploadBtn)
				{
					if(!startBtn)
						startBtn = startUploadBtn;
					else
					{
						startUploadBtn.text("Waiting..");
						hasBtns = true;
					}
				}
			});
			if($.CrushFTP.uploadAllQueued && !startBtn && !hasBtns)
			{
				$.growlUI("Upload Completed", "All files uploaded.", $.CrushFTP.Options.GrowlTimeout);
				fileRepo.find(".curQueue").removeClass("curQueue");
				$.CrushFTP.removeGlobalProgressInfo();
			}
		}
		else
		{
			var fileItem = fileRepo.find("li.queued:not(.uploaded, .error, .skipped, .ui-state-highlight, .hasError, .warning):first");
			if(fileItem.length>0)
			{
				fileItem.removeClass("queued");
				startBtn = fileItem.find("a.startUpload");
			}
		}
		return startBtn;
	}

	$.CrushFTP.bindUploadItemEvents = function()
	{
		//Native upload items
		var allItems = fileRepo.find("li");
		allItems.find("a.cancelUpload").unbind().click(function(){
			var elem = $(this).closest("li");
			if(elem.hasClass("uploadProgress"))
			{
				if(confirm("Are you sure you wish to cancel this upload?"))
				{
					if(elem.hasClass("appletItem"))
					{
						var resume = elem.find("a.pause").hasClass("resume");
						var globalPBPauseBtn = globalProgressBar.find("a.pause");
						if(resume)
						{
							elem.find("a.pause").removeClass("resume").text("Pause");
							elem.find(".status").html("Cancelling..");
							elem.removeClass("paused");
							globalPBPauseBtn.removeClass("resume").text("Pause");
							globalProgressBar.find(".speed,.time").show();
							globalProgressBar.find(".statusPB").remove();
						}
						runAppletCommand(true, "COMMAND=ACTION:::TYPE=UPLOAD:::ACTION=CANCEL");
						elem.attr("status", "skipped");
					}
					else
						$.CrushFTP.abortUploadRequest(elem);

					$.CrushFTP.DNDUploadCallback("skipped", false, elem.find("a.startUpload"), elem);
				}
			}
			else
			{
				elem.remove();
				$.CrushFTP.buildQueueInfo();
			}
			return false;
		});

		allItems.find("a.startUpload").unbind().click(function(e, data){
			if(data && data.allInQueue)
				$.CrushFTP.uploadAllQueued = true;
			var listElem = $(this).closest("li.formProcessed");
			if($.CrushFTP.UploadProgressing)
			{
				$(this).text("Waiting..");
				if(!dragEventsNotSupported)
				{
					if(listElem.hasClass("uploaded") || listElem.hasClass("skipped"))
					{
						var curSize = parseInt(listElem.attr("size"));
						if(IsNumeric(curSize))
						{
							var guploadInfo = globalProgressBar.data("uploadInfo");
							if(guploadInfo)
							{
								guploadInfo.totalUploaded -= curSize;
								guploadInfo.curfile -= 1;
							}
							globalProgressBar.data("uploadInfo", guploadInfo);
						}
					}
				}
				if(!$.CrushFTP.uploadAllQueued)
				{
					listElem.addClass("queued curQueue").removeClass("uploaded error hasError skipped");
				}
				else
				{
					listElem.removeClass("uploaded error hasError skipped");
				}
				return false;
			}
			else
				$.CrushFTP.uploadAllQueued = data && data.allInQueue;
			if(listElem && listElem.length>0)
			{
				if(listElem.hasClass("skipped"))
					listElem.removeClass("skipped");

				listElem.addClass("curQueue").removeClass("hasError");
				if(listElem.hasClass("appletItem"))
				{
					listElem.find("a.start").trigger("click");
				}
				else
				{
					$.ajax({
						type: "POST",
						url: $.CrushFTP.Options.ajaxCallURL,
						data: "command=unblockUploads&random=" + Math.random(),
						success: function (response) {
							listElem.find("a.start").trigger("click");
							listElem.find(".progressbar").progressbar({"value" : 0});
							var guploadInfo = globalProgressBar.data("uploadInfo");
							if(!dragEventsNotSupported && guploadInfo)
							{
								globalProgressBar.show();
							}
							else
								globalProgressBar.find(".progressbarMain").progressbar({"value" : 0});
						}
					});
				}
			}
			return false;
		});

		//Applet items
		var appletItems = fileRepo.find(".appletItem");
		appletItems.find("a.start").unbind().click(function(){
			if(!$.CrushFTP.UploadProgressing)
			{
				var listElem = $(this).closest("li");
				$.CrushFTP.startAppletItemUpload(listElem);
				listElem.find(".progressbar").progressbar({"value" : 0});
				globalProgressBar.find(".progressbarMain").progressbar({"value" : 0});
			}
			return false;
		});

		appletItems.find("a.pause").unbind().click(function(){
			var resume = $(this).hasClass("resume");
			var parentElem = $(this).closest("li");
			var globalPBPauseBtn = globalProgressBar.find("a.pause");
			if(resume)
			{
				$(this).removeClass("resume").text("Pause");
				parentElem.find(".status").html("Resuming..");
				parentElem.removeClass("paused");
				globalPBPauseBtn.removeClass("resume").text("Pause");
				globalProgressBar.find(".speed,.time").show();
				globalProgressBar.find(".statusPB").remove();
			}
			else
			{
				if(!parentElem.hasClass("uploadProgress"))return false;
				$(this).addClass("resume").text("Resume");
				parentElem.addClass("paused");
				globalPBPauseBtn.removeClass("resume").text("Resume");
				globalProgressBar.find(".speed,.time").hide();
				globalProgressBar.find(".progressInfoText").append('<span class="statusPB" style="float:left;font-weight:bolder;margin-top:3px;">Paused</span>');
			}
			$.CrushFTP.pauseResumeAppletItemUpload(parentElem, !resume);
			return false;
		});

		appletItems.each(function(){
			var item = $(this);
			var fileInfo = item.data("fileInfo");
			if(!fileInfo)return;
			var ext = getFileExtension(fileInfo.name);
			var imgSrc = "";
			if ($.CrushFTP.Options.availableFileExtensionImages.has(ext)) {
				imgSrc = $.CrushFTP.Options.FileExtensionImageFilePath + ext + "_32.png";
			} else {
				imgSrc = $.CrushFTP.Options.fileLarge + "_32.png";
			}
			if(imgSrc.length>0)
				item.find("div.preview").find("span.fade").empty().append("<img style='margin-top:5px;' src='"+imgSrc+"'/>");
		});
	}

	$.CrushFTP.startAppletItemUpload = function(item)
	{
		if(!item)return;
		var fileInfo = item.data("fileInfo");
		if(!fileInfo)return;
		item.find("a.pause").removeClass("resume").text("Pause");
		item.find(".status").html("Starting Upload..");
		item.removeClass("paused");
		var globalPBPauseBtn = globalProgressBar.find("a.pause");
		globalPBPauseBtn.removeClass("resume").text("Pause");
		globalProgressBar.find(".speed,.time").show();
		globalProgressBar.find(".statusPB").remove();
		var url = location.protocol + "//" + location.host + "" + fileInfo.path;
		var formData = item.data("formData") || "";
		if(formData)
		{
			formData = formData.replace(/&/g, ':::').replace(/&/g, ':::');
		}
		var resumeUpload = ":::RESUME=" + AdvancedBrowseResumeOption.find("input").is(":checked");
		var compressionUpload = ":::NOCOMPRESSION=" + ($.cookie("__WEBINTERFACE_NOCOMPRESSION") == "true");
		var cmd = "COMMAND=UPLOAD:::URL="+url+":::UPLOADPATH=" + fileInfo.path + ":::P1=" + fileInfo.sourcePath + ":::" + formData + resumeUpload + compressionUpload;
		runAppletCommand(true, "COMMAND=AUTH:::CRUSHAUTH=" + $.cookie("CrushAuth"));
		runAppletCommand(true, cmd);
		$.CrushFTP.DNDUploadCallback("uploading", false, item.find("a.startUpload"), item);
	}

	$.CrushFTP.pauseResumeAppletItemUpload = function(item, pause)
	{
		if(!item)return;
		var fileInfo = item.data("fileInfo");
		if(!fileInfo)return;

		var cmd = "COMMAND=ACTION:::TYPE=UPLOAD:::ACTION=RESUME";
		if(pause)
			cmd = "COMMAND=ACTION:::TYPE=UPLOAD:::ACTION=PAUSE";

		runAppletCommand(true, "COMMAND=AUTH:::CRUSHAUTH=" + $.cookie("CrushAuth"));
		runAppletCommand(true, cmd);
		if(pause)
		{
			item.attr("status", "paused");
			$.CrushFTP.DNDUploadCallback("paused", false, item.find("a.startUpload"), item);
		}
		else
		{
			item.removeAttr("status");
			$.CrushFTP.DNDUploadCallback("uploading", false, item.find("a.startUpload"), item);
		}
	}


	$.CrushFTP.showUploadForm = function(elem)
	{
		if($.CrushFTP.fetchingUploadForm)return;
		if ($("#customUploadForm").length > 0) {
			$.CrushFTP.fetchingUploadForm = true;
			getUploadForm(function (data) {
				$.CrushFTP.fetchingUploadForm = false;
				if(data && data.length>0)
				{
					data = $(data);
					data.append("<tr id='uploadFormDataCheckbox'><td colspan='2' style='border:none;'><p class='formOption ui-state-highlight'><input type='checkbox' id='useUploadFormForAll' /><label for='useUploadFormForAll'>Don't show form for additional files.</label></p></td></tr>");
					var formContent = $("#uploadInfoForm").find(".formContent").replaceWith(data);
					setCustomFormFieldAttributes(formContent);
					attachCalendarPopup(formContent);
					$.CrushFTP.uploadInfoFormDialog.data("elem", elem);
					$.CrushFTP.uploadInfoFormDialog.find("#uploadFormDataCheckbox").show();
					$.CrushFTP.uploadInfoFormDialog.dialog("open");
				}
				else
					$.CrushFTP.storeUploadFormDataToItems();
			}, function(){
			});
		}
		else
		{
			$.CrushFTP.storeUploadFormDataToItems();
			$.CrushFTP.fetchingUploadForm = false;
		}
	};

	$.CrushFTP.storeUploadFormDataToItems = function(formData, elem){
		var items = elem;
		if(!items || items.length==0)
		{
			items = fileRepo.find("li:not(.formProcessed)").addClass("formProcessed");
		}
		if(formData)
		{
			items.data("formData", formData);
			items.find(".editForm").parent().show().end().unbind("click").click(function(){
				var listElem = $(this).closest("li.formProcessed");
				if(listElem && listElem.length>0)
					$.CrushFTP.showUploadForm(listElem);
				return false;
			});
		}
		else
		{
			items.find(".editForm").parent().hide();
		}
	};

	$.CrushFTP.checkFileExistOnServer = function(name, _path) {
		name = name.toLowerCase();
		_path = _path || "/";
		var destinationPath = encodeURIComponent(hashListener.getHash().toString().replace("#", ""));
		destinationPath = destinationPath || "/";
		destinationPath = unescape(destinationPath);
		if(_path != destinationPath) return false;
		var fileAvl = false;
		if (window.curTreeItems) {
			$.each(window.curTreeItems, function () {
				if ($.trim($(this)[0].name).toLowerCase() === $.trim(name)) {
					fileAvl = true;
				}
			});
		}
		return fileAvl;
	};

	$.CrushFTP.handleWarnings = function() {
		fileRepo.find(".fileExistOnServer").each(function(){
			var item = $(this).removeClass("fileExistOnServer").closest("li");
			item.addClass("ui-state-highlight");
			$(this).hide().after('<div class="overwrite" style="float:right;margin-top:17px;"><a href="javascript:void(0);" class="overwriteLink">Overwrite</a></div>').parent().find("div.overwrite").click(function(){
				$(this).remove();
				item.removeClass("ui-state-highlight").find("div.startUpload").show().end().find(".error").remove();
				if(fileRepo.find("ul").find("a.overwriteLink:visible").length>0)
					overwriteAllLinkBtn.show();
				else
					overwriteAllLinkBtn.hide();
				return false;
			}).parent().append("<span class='error'>Error : File exists on server</span>");
		});

		var bigFiles = [];
		fileRepo.find(".fileBiggerThanAllowed").each(function(){
			var item = $(this).removeClass("fileExistOnServer").closest("li");
			bigFiles.push(item.find("div.name").text());
		});
		if(bigFiles.length>0)
		{
			$.growlUI("For bigger files use advanced upload", "<span class='growlNote'>It is advised to use advanced upload for bigger files, it allows to upload files easily and has <em>auto resume</em> feature. <br><br> (You can switch upload mode in Upload Bar)</span><br><img src='/WebInterface/jQuery/images/UploadBarGuide.png' style='padding-top:10px;margin-left:-45px;' title='How to switch upload mode'>", $.CrushFTP.Options.GrowlTimeout + 10000, "growlWarning", true);
		}
	};

	$.CrushFTP.fileCount = 0;

	var dragEventsNotSupported = !$.CrushFTP.browserSupportsDND();
	//Get val type
	$.CrushFTP.getType = function(val) {
		if (val === null) return "[object Null]";
		return Object.prototype.toString.call(val);
	}

	$.CrushFTP.getActionResponseText = function(msg) {
		var responseText = '';
		try {
			var msgs = msg.getElementsByTagName("commandResult");
			for (var x = 0; x < msgs.length; x++) {
				responseText += IE(msgs[x].getElementsByTagName("response")[0]).textContent;
			}
		} catch (ex) {}
		return responseText;
	}

	$.CrushFTP.attachDND = function(o)
	{
		$.CrushFTP.Options = o;
		css_browser_selector(navigator.userAgent);
		browseFileButtonPanel.find("#browseFileButton").unbind().click(function(){
			window.command_id = runAppletCommand(true, "COMMAND=BROWSE:::TITLE=" + getLocalizationKeyExternal("advancedUploadItemsSelectionWindowTitle"), true);function getBrowseSelection() {
				var result = {};
				if ($("#javaApplet").length > 0) result = $("#javaApplet")[0].getASyncResult(window.command_id);
				else {
					alert(getLocalizationKeyExternal("AppletLoadingFailedMsgText"));
					return false;
				}
				if (result) {
					window.handleAppletDND(result);
				} else {
					if ($.CrushFTP.getType(result).toLowerCase().indexOf("string") < 0) {
						setTimeout(function () {
							getBrowseSelection();
						}, 200);
					}
				}
			}
			getBrowseSelection();
		});

		var browseTypeSelector = $("#browseTypeSelector").unbind().click(function(){
			var cluetipTitle = $("#cluetip-title");
			$("#cluetip").hide();
			if($(this).hasClass("normal"))
			{
				switchUploadType("advanced", $(this));
				var tipInfo = $(this).data('thisInfo');
				if(tipInfo)
				{
					var _title = "Switch to Normal Upload";
					$(this).data('thisInfo', {title: _title, zIndex: tipInfo.zIndex});
					cluetipTitle.text(_title);
				}
			}
			else
			{
				switchUploadType("normal", $(this));
				var tipInfo = $(this).data('thisInfo');
				if(tipInfo)
				{
					var _title = "Switch to Advanced Upload";
					$(this).data('thisInfo', {title: _title, zIndex: tipInfo.zIndex});
					cluetipTitle.text(_title);
				}
			}
			$(this).blur();
			return false;
		});

		bindAppletDND();
		switchUploadType(browseTypeSelector.hasClass("normal") ? "normal" : "", browseTypeSelector);
		fileRepo.draggable({
			handle : ".fileListHeader"
		});

		$.CrushFTP.uploadInfoFormDialog = $("#uploadInfoForm").dialog({
			autoOpen: false,
			width: 650,
			modal: true,
			resizable: false,
			closeOnEscape: false,
			buttons: {
				"Cancel" : function(){
					var notProcessed = fileRepo.find("li:not(.formProcessed)");
					var elem = $.CrushFTP.uploadInfoFormDialog.data("elem");
					if(!elem)
					{
						if(confirm("Are you sure you wish to cancel upload for last selected "+ notProcessed.length +" item(s)?"))
						{
							notProcessed.each(function(){
								$(this).find(".cancelUpload").trigger("click");
							});
							$(this).dialog("close");
						}
					}
					else
						$(this).dialog("close");
					return false;
				},
				"Ok": function() {
					var that = $(this);
					if (validateForm(false, $.CrushFTP.uploadInfoFormDialog.find(".customForm")))
					{
						var formData = serializeForm($.CrushFTP.uploadInfoFormDialog.find("form")[0], true);
						if($("#useUploadFormForAll", $.CrushFTP.uploadInfoFormDialog).is(":checked") && !$.CrushFTP.uploadFormInfo)
						{
							$.CrushFTP.uploadFormInfo = formData;
						}
						var elem = $.CrushFTP.uploadInfoFormDialog.data("elem");
						$.CrushFTP.storeUploadFormDataToItems(formData, elem);
						$.CrushFTP.uploadInfoFormDialog.removeData("elem");
						$.CrushFTP.uploadInfoFormDialog.find("form").submit();
						$(this).dialog("close");
					}
				}
			},
			open: function(){
				$(".ui-dialog-titlebar-close").hide();
				var elem = $.CrushFTP.uploadInfoFormDialog.data("elem");
				if(elem)
				{
					var formData = elem.data("formData");
					if(formData)
					{
						window.bindDataToForm($.CrushFTP.uploadInfoFormDialog, formData);
					}
					$.CrushFTP.uploadInfoFormDialog.find("#uploadFormDataCheckbox").hide();
				}
				setTimeout(function(){
					$.CrushFTP.uploadInfoFormDialog.find("input, select, textarea").unbind("change").change(function(){
						$.CrushFTP.uploadInfoFormDialog.find("#meta_unique_upload_id").val(generateRandomPassword(4));
					});
				}, 100);
			}
		});

		function switchUploadType(type, elm)
		{
			if(type == "normal")
			{
				bindNativeDND();
				elm.removeClass("advanced").addClass("normal").find("span.type").text("Normal");
				browseFileButtonPanel.find("input").show();
				$.CrushFTP.browseAdvanced = false;
				if(dragEventsNotSupported)
				{
					 $(document).unbind('dragover');
				}
				window.cancelDropAction(true);
				AdvancedBrowseResumeOption.hide();
			}
			else
			{
				bindNativeDND(!is_MacOs);
				AdvancedBrowseResumeOption.show("fast");
				$.CrushFTP.browseAdvanced = true;
				elm.removeClass("normal").addClass("advanced").find("span.type").text("Advanced");
				browseFileButtonPanel.find("input").hide();
				if(dragEventsNotSupported && !is_MacOs)
					window.showDropArea();
				if (!$.CrushFTP.appletDNDAdded)
				{
					$.CrushFTP.appletDNDAdded = true;
					elm.parent().append("<span class='spinner' style='display: inline-block;padding-left: 20px;float: left;top: 5px;position: relative;margin: 0px 6px;'>Loading...</span>");
					$("#javaAppletDiv").css("left", "0px");
					loadApplet(true, function () {
						elm.parent().find("span.spinner").remove();
						if (dragEventsNotSupported) {
							window.showDropArea();
							$(window).bind("resize", function () {
								window.showDropArea();
							});
							setTimeout(listenAppletDrop, 500);
						}
						else
							$("#javaAppletDiv").css("left", "5000px");
					});
				}
			}
		}

		function bindNativeDND(disableDragOver){
			if(disableDragOver)
			{
				$.CrushFTP.uploadElem = $("#fileupload").crushftp_DNDUpload({disableDragOver : true});
			}
			else
			{
				var dropItemsPanel = $("#dropItemsPanel");
				var fileQueueInfo = $("#fileQueueInfo");
				$.CrushFTP.uploadElem = $("#fileupload").crushftp_DNDUpload({
					fileuploaddropEvent : function(e, data)
					{
						var target = $(e.target);
						processAddedFiles(target, data, false, true);
						e.stopPropagation();
					},
					documentDragEvent : function(e)
					{
						dropItemsPanel.show();
						if(dropItemsPanel.hasClass("stick"))
							fileQueueInfo.css("z-index", 0);
					},
					documentDropEvent : function(e)
					{
						dropItemsPanel.hide();
						if(dropItemsPanel.hasClass("stick"))
							fileQueueInfo.css("z-index", 98);
					},
					fileuploadadded : function(e, data)
					{
						$.CrushFTP.buildQueueInfo();
						fileRepo.find(".dirNoWritable").each(function(){
							$(this).closest("li").find("a.cancelUpload").trigger("click");
						});
						if(!data.files[0].error && !$.CrushFTP.uploadFormInfo)
							$.CrushFTP.showUploadForm();

						if($.CrushFTP.uploadFormInfo)
						{
							var elem = fileRepo.find("li:not(.formProcessed)").addClass("formProcessed");
							$.CrushFTP.storeUploadFormDataToItems($.CrushFTP.uploadFormInfo, elem);
						}
						$.CrushFTP.showIconsForFiles();
						$.CrushFTP.handleWarnings();
					},
					fileuploadchange : function(e, data)
					{
						if(!data || !data.files)return;
						processAddedFiles(false, data);
						$.CrushFTP.buildQueueInfo();
						e.stopPropagation();
					},
					fileuploaddestroyed : function(e, data)
					{
						$.CrushFTP.buildQueueInfo();
					}
				});
			}
		}

		function bindAppletDND()
		{
			//Show drop area on upload window
			window.showDropArea = function () {
				if (!$(document).data("appletLoaded")) return false;
				javaAppletDiv.css({
					"position": "relative",
					"margin": "0px",
					"padding": "0px",
					"left" : "0px"
				});
				javaAppletDiv.addClass('dragOver');
			}

			//Cancel drop action
			window.cancelDropAction = function (ignoreBrowser) {
				if (dragEventsNotSupported && !ignoreBrowser) return false; //IE issue fix
				javaAppletDiv.css({
					"position": "absolute",
					"left" : "-5000px"
				});
			}

			window.listenAppletDrop = function(){
				if($.CrushFTP.browseAdvanced)
				{
					var s = runAppletCommand(true, "COMMAND=DND:::");
					if (s && s != "") {
						handleAppletDND(s);
						while (s != "") {
							s = runAppletCommand(true, "COMMAND=DND:::");
							if (s && s != "") {
								handleAppletDND(s);
							}
						}
						window.cancelDropAction();
					}
				}
				if(!dragEventsNotSupported)
				{
					if (new Date() - $(document).data("dndActiveAt") > 1000)
						window.cancelDropAction();
					else
						setTimeout(listenAppletDrop, 500);
				}
				else
					setTimeout(listenAppletDrop, 500);
			}

			//Parse java properties
			window.parseJavaProps = function(s) {
				var o = {};
				if (s) {
					var item_props = s.split(":::");
					for (var xx = 0; xx < item_props.length; xx++) {
						o[item_props[xx].substring(0, item_props[xx].indexOf("="))] = item_props[xx].substring(item_props[xx].indexOf("=") + 1); //set the key, and value on the o object
					}
				}
				return o;
			}

			window.handleAppletDND = function(result)
			{
				result = result + ""; //need to conver this JavaRuntimeObject to a String
				var destinationPath = hashListener.getHash().toString().replace("#", "") || "/";
				var itemList = new Array();
				var items = result.split(";;;");
				for (var x = 0; x < items.length; x++) {
					var o = parseJavaProps(items[x]);
					if(o && o.name)
					{
						o.destinationPath = destinationPath;
						o.fromApplet = true;
						o.sourcePath = o.path;
						o.size = parseInt(o.size);
						itemList[itemList.length] = o;
					}
				}
				if (itemList.length > 0) {
					processAddedFiles(fileRepo, {files : itemList}, true);
				}
			}

			if(!dragEventsNotSupported && !is_MacOs)
			{
				addEvent($(document), "dragenter", function (e) {
					if($.CrushFTP.browseAdvanced)
					{
						$(document).data("dndActiveAt", new Date() * 1);
						if (e.preventDefault) e.preventDefault();
						if (!$(document).data("appletLoaded")) {
							$.growlUI(getLocalizationKeyExternal("JavaAppletNotLoadedGrowlText"), getLocalizationKeyExternal("JavaAppletNotLoadedDescGrowlText"), o.GrowlTimeout, "growlError", o.GrowlWithCloseButton);
							return false;
						}
						window.showDropArea();
						setTimeout(listenAppletDrop, 500);
					}
					return false;
				});

				addEvent($(document), "dragover", function cancel(e) {
					if($.CrushFTP.browseAdvanced)
					{
						$(document).data("dndActiveAt", new Date() * 1);
						if (e.preventDefault) e.preventDefault();
					}
					return false;
				});

				addEvent($(document), "drop", function (e) {
					if($.CrushFTP.browseAdvanced)
					{
						if (e.preventDefault) e.preventDefault();
						window.cancelDropAction(true);
					}
					return false;
				});
			}
		}

		function isFileBigger(size) {
			if(!size) return false;
			var sizeInMB = size / 1024 / 1024;
			if(!$.CrushFTP.maxFileSizeAllowedInNormalUploadInMB) return false;

			if(sizeInMB<=$.CrushFTP.maxFileSizeAllowedInNormalUploadInMB)
				return false;
			else
				return true;
		}

		function renderTemplate(func, files) {
            if (!func) {
                return $();
            }
            var result = func({
                files: files,
                formatFileSize: $.CrushFTP.formatBytes
            });
            if (result instanceof $) {
                return result;
            }
            return result;
        }

		var tmplFn = tmpl("template-upload");
		function processAddedFiles(target, data, applet, isDropped)
		{
			var path = "";
			var privs = $(document).data("folderPrivs");
			if(!target) target = $();
			if(!target.hasClass("dropzone"))
			{
				target = target.closest(".dropzone");
			}
			if(target.hasClass("directoryThumb"))
			{
				path = target.find("a.imgLink").attr('rel').match(/.*\//);
				if(target.data("dataRow")){
					privs = target.data("dataRow").privs.toString();
				}
			}
			else if(target.hasClass("directoryTree"))
			{
				path = target.find("a:first").attr('rel').match(/.*\//);
				privs = target.attr("privs");
			}
			else{
				var destinationPath = encodeURIComponent(hashListener.getHash().toString().replace("#", ""));
				destinationPath = destinationPath || "/";
				path = destinationPath;
			}
			var _write = privs.indexOf("(write)")>=0;
			var hasError = false;
			$.each(data.files, function (index, file) {
				file.privs = privs;
				if(!applet)
					file.path = unescape(path);
				else
					file.path = unescape(file.destinationPath);
				file.isDropped = isDropped;
				file.FullPath = escape(file.path + file.name);
				if(typeof file.curCount == "undefined")
				{
					file.curCount = $.CrushFTP.fileCount;
					$.CrushFTP.fileCount+=1;
				}
				if(fileRepo.find("li[fullPath='"+file.FullPath+"']").length>0)
				{
					file.error = "fileAvailableInSelectedFolder";
					hasError = true;
				}
				else if($.CrushFTP.checkFileExistOnServer(file.name, file.path))
				{
					file.warning = "fileExistOnServer";
				}
				if(!applet && file.size)
				{
					if(isFileBigger(file.size))
					{
						file.warning = "fileBiggerThanAllowed";
					}
				}
				if(!_write)
				{
					file.error = "dirNoWritable";
					hasError = true;
				}
			});
			if(!_write)
			{
				$.growlUI(getLocalizationKeyExternal("NoUploadInDirGrowlText"), getLocalizationKeyExternal("NoUploadInDirGrowlDesc") + "<br/>" + unescape(path), o.GrowlTimeout, "growlError");
			}
			else if(applet)
			{
				if(hasError)
					data.files.valid = false;
				else
					data.files.valid = true;
				var html = $(renderTemplate(tmplFn, data.files));
				var newItems = $(html);
				fileRepo.find("ul").append(newItems);
				var curIndex = 0;
				newItems.each(function(){
					if($(this).is("li"))
					{
						$(this).data("fileInfo", data.files[curIndex]).attr("uid", generateRandomPassword(8));
						curIndex+=1;
					}
				});
				fileRepo.find(".dirNoWritable").each(function(){
					$(this).closest("li").find("a.cancelUpload").trigger("click");
				});
				if(!data.files[0].error && !$.CrushFTP.uploadFormInfo)
					$.CrushFTP.showUploadForm();

				if($.CrushFTP.uploadFormInfo)
				{
					var elem = fileRepo.find("li:not(.formProcessed)").addClass("formProcessed");
					$.CrushFTP.storeUploadFormDataToItems($.CrushFTP.uploadFormInfo, elem);
				}
				$.CrushFTP.handleWarnings();
				$.CrushFTP.buildQueueInfo();
			}
		}
		/*Init code*/
		$.CrushFTP.bindUploadEvents();
		viewFileQueue.hover(function() {
			if($(this).hasClass("close"))
	        	$(this).stop().animate({ top: "0px" }, 200);
	       	else
	       		$(this).stop().animate({ top: "10px" }, 200);
	    },function(){
	        $(this).stop().animate({ top: "4px" }, 300);
	    });

	    fileRepo.bind("visibilityChange", function(){
			if(fileRepo.is(":visible"))
				viewFileQueue.addClass("close");
			else
				viewFileQueue.removeClass("close");
	    });
	}

	$.CrushFTP.refreshProgressInfo = function(elem){
		if(elem.hasClass("skipped"))
		{
			$.CrushFTP.processStatusOfUpload(elem, "error");
			return;
		}
		var isApplet = elem.hasClass("appletItem");
		$.CrushFTP.getUploadProgress(function(result){
			$.CrushFTP.updateProgressBar(elem);
			var status = elem.data("uploadInfo").status;
			if(isApplet) status = elem.data("uploadInfo").statusApplet;
			$.CrushFTP.processStatusOfUpload(elem, status);
		}, elem, isApplet);
	}

	$.CrushFTP.processStatusOfUpload = function(elem, status)
	{
		var progressInfo = elem.find("div.progressInfo");
		if(status == "completed")
		{
			if(elem.hasClass("appletItem"))
			{
				setTimeout(function(){
					elem.removeClass("uploadProgress").addClass("uploaded").find("a.startUpload").text(locale.fileupload.reupload).show();
					if(elem.data("formData"))
						elem.find("a.editForm").parent().show();
					elem.find("a.pause").parent().hide();
					progressInfo.hide();
				}, 200);
			}
			elem.removeClass("uploadProgress").addClass("uploaded").find("a.startUpload").text(locale.fileupload.reupload).show();
			if(elem.data("formData"))
				elem.find("a.editForm").parent().show();
			progressInfo.hide();
			if($.CrushFTP.uploadAllQueued)
			{
				var btn = $.CrushFTP.getNextQueuedItem();
				if(btn)
				{
					$.CrushFTP.UploadProgressing = false;
					btn.trigger("click", [{allInQueue:true}]);
				}
				else
				{
					$.CrushFTP.removeGlobalProgressInfo();
				}
			}
			else
			{
				$.CrushFTP.UploadProgressing = false;
				var btn = $.CrushFTP.getNextQueuedItem(true);
				if(btn && btn.length>0)
				{
					btn.trigger("click");
				}
				else
				{
					$.growlUI("Upload Completed", "File uploaded to server.", $.CrushFTP.Options.GrowlTimeout);
					fileRepo.find(".curQueue").removeClass("curQueue");
					$.CrushFTP.removeGlobalProgressInfo();
				}
			}

			if(fileRepo.find("li.uploaded").length>0)
				clearUploadedAll.show();
			else
				clearUploadedAll.hide();

			refreshBtn.trigger("click");
		}
		else if(status == "error")
		{
			elem.removeClass("uploadProgress").addClass("hasError").find("a.startUpload").text(locale.fileupload.reupload).show();
			if(elem.data("formData"))
				elem.find("a.editForm").parent().show();
			if($.CrushFTP.uploadAllQueued)
			{
				var btn = $.CrushFTP.getNextQueuedItem();
				if(btn)
				{
					$.CrushFTP.UploadProgressing = false;
					btn.trigger("click", [{allInQueue:true}]);
				}
				else
				{
					$.CrushFTP.removeGlobalProgressInfo();
				}
			}
			else
			{
				$.CrushFTP.UploadProgressing = false;
				var btn = $.CrushFTP.getNextQueuedItem(true);
				if(btn && btn.length>0)
				{
					btn.trigger("click");
				}
				else
				{
					$.CrushFTP.removeGlobalProgressInfo();
				}
			}
			progressInfo.hide();
		}
		else
		{
			if(!elem.hasClass("skipped"))
			{
				setTimeout(function(){
					$.CrushFTP.refreshProgressInfo(elem);
				}, 1000);
			}
		}
	}

	$.CrushFTP.abortUploadRequest = function(elem){
		$.ajax({
			type: "POST",
			url: $.CrushFTP.Options.ajaxCallURL,
			data: "command=blockUploads&random=" + Math.random(),
			success: function (response) {
			}
		});
	};

	$.CrushFTP.getBatchInfo = function(isBatch)
	{
		var totalSize = 0;
		var totalFiles = 0;
		if(isBatch)
		{
			var itms = fileRepo.find("li:not(.error, .ui-state-highlight, .hasError, .warning)").each(function(){
				var curSize = parseInt($(this).attr("size"));
				if(IsNumeric(curSize))
				{
					totalSize += curSize;
				}
			});
			totalFiles = itms.length;
		}
		else
		{
			var itms = fileRepo.find("li.curQueue:not(.error, .ui-state-highlight, .hasError, .warning)").each(function(){
				var curSize = parseInt($(this).attr("size"));
				if(IsNumeric(curSize))
				{
					totalSize += curSize;
				}
			});
			totalFiles = itms.length;
		}
		return {
			size : totalSize,
			files : totalFiles
		};
	}

	$.CrushFTP.updateProgressBar = function(elem){
		var uploadInfo = elem.data("uploadInfo");
		var progressInfo = elem.find("div.progressInfo");
		if(!uploadInfo) return;
		var now = new Date().getTime();
		if (!uploadInfo.history) uploadInfo.history = new Array();
		//calculate speeds using a rolling 10 interval window.  This provides a smoother speed calculation that doesn't bounce around so much to make the user concerned
		var history = uploadInfo.history;//Progressbar data history
		var currentSpeed = uploadInfo.currentSpeed;//Current upload/download speed
		var speedHistory = uploadInfo.speedHistory || [];
		history.push({
			now: now,
			bytes: uploadInfo.part1
		});
		if (history.length > 1 && elem.hasClass("paused") == false) {//Calculation and updating progressbar. Calculation of speed, percentages etc.
			var pivot = 0; //If history is for less than 5 seconds, use data of first second
			if (history.length > 5) {
				pivot = history.length - 5; // Set pivot to be of previous five second
			}
			var elapsed = now - history[0].now; // Time elapsed
			var bytes = uploadInfo.part1 - history[pivot].bytes; // Bytes transferred in timeframe
			var lastElapsed = now - history[pivot].now;// Elapsed time for last transfer timeframe
			var originalBytes = uploadInfo.part1 - history[0].bytes; // total bytes transferred
			var secs = ((((uploadInfo.part2 - uploadInfo.part1) / (originalBytes / elapsed)) / 1000) + 1) + ""; // total time remaining
			var remaining = $.CrushFTP.formatTime(secs);//formatted time
			var percentDone = (uploadInfo.part1 / uploadInfo.part2) * 100.0;// percentages completed
			var rElapsed = $.CrushFTP.formatTime((elapsed / 1000) + 1 + "");// elapsed time formatted
			var speed = "";
			var currentActualSpeed = 0;
			if ((originalBytes / elapsed) == 0) {// Still Calculating
				speed = getLocalizationKeyExternal("BrowserUploaderSpeedTimeCalculatingText");
				remaining = getLocalizationKeyExternal("BrowserUploaderSpeedTimeCalculatingText");
				uploadInfo.currentSpeed = speed;
			} else {
				currentActualSpeed = (bytes / lastElapsed) * 1024.0;
				speed = $.CrushFTP.formatBytes(currentActualSpeed) + "/s";// Based on data transferred in last timeframe (5 secs)
				uploadInfo.currentSpeed = speed;
			}
			var uploadedSize = $.CrushFTP.formatBytes(uploadInfo.part1);
			var originalSize = $.CrushFTP.formatBytes(uploadInfo.part2);
			uploadInfo.originalSize = originalSize;
			progressInfo.find(".time,.speed,.status,.uploadStatusLabel").remove();
			progressInfo.append('<span class="uploadStatusLabel">' + uploadedSize + ' of ' + originalSize + '</span>');
			var timeStampLabel = getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingTimeText");
			timeStampLabel = timeStampLabel.replace("{0}", rElapsed);
			timeStampLabel = timeStampLabel.replace("{1}", remaining);
			progressInfo.append(timeStampLabel);
			if(elapsed/1000 >= 20)
			{
				speedHistory.push(currentActualSpeed);
				uploadInfo.speedHistory = speedHistory;
				var getAverageSpeed = function()
				{
					if(speedHistory.length>30)
					{
						while (speedHistory.length > 30) speedHistory.shift();
					}
					var avgSpeed = speedHistory.average();
					if(avgSpeed>0)
					{
						return getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingAverageSpeedText") + $.CrushFTP.formatBytes(avgSpeed) + "/s , ";
					}
					else
						return "";
				}
				progressInfo.append("<div class='speed'>" + getAverageSpeed() + getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingSpeedText") + speed + "</div>");
			}
			else
			{
				progressInfo.append("<div class='speed'>" + getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingSpeedText") + speed + "</div>");
			}
			if(uploadInfo.part1>0)
				progressInfo.find(".progressbar").progressbar({"value" : percentDone});

			//Global Progressbar
			if(!dragEventsNotSupported)
			{
				var batchInfo = $.CrushFTP.getBatchInfo($.CrushFTP.uploadAllQueued);
				var totalSize = batchInfo.size;
				var guploadInfo = globalProgressBar.data("uploadInfo");
				var prevFileSize = 0;
				var lastFile = globalProgressBar.data("curFile");
				globalProgressBar.data("curFile", elem.attr("uid"));
				if(!guploadInfo)
				{
					guploadInfo = {part1 : 0, part2 : 0, totalUploaded : 0, curfile:1, status : "", history : new Array()};
				}
				if(lastFile && lastFile != elem.attr("uid"))
				{
					prevFileSize = globalProgressBar.data("curFileSize");
					guploadInfo.totalUploaded += prevFileSize;
					guploadInfo.curfile += 1;
				}
				else
				{
					globalProgressBar.data("curFileSize", uploadInfo.part2);
				}
				guploadInfo.part2 = totalSize;
				guploadInfo.part1 = guploadInfo.totalUploaded + uploadInfo.part1;
				guploadInfo.status = uploadInfo.status;
				globalProgressBar.data("uploadInfo", guploadInfo);
				$.CrushFTP.updateGlobalProgressBar(elem, batchInfo.files, guploadInfo.curfile);
			}
			else
			{
				var batchInfo = $.CrushFTP.getBatchInfo($.CrushFTP.uploadAllQueued);
				var totalSize = batchInfo.size;
				var lastFile = globalProgressBar.data("curFile");
				globalProgressBar.data("curFile", elem.attr("uid"));
				var curFileCount = globalProgressBar.data("curFileCount");
				if(!curFileCount)
					curFileCount = 1;
				if(lastFile && lastFile != elem.attr("uid"))
				{
					curFileCount += 1;
					globalProgressBar.data("curFileCount", curFileCount);
				}
				globalProgressBar.data("uploadInfo", uploadInfo);
				$.CrushFTP.updateGlobalProgressBar(elem, batchInfo.files, curFileCount);
			}
		}
	}

	$.CrushFTP.updateGlobalProgressBar = function(elem, totalFiles, curFile)
	{
		var uploadInfo = globalProgressBar.data("uploadInfo");
		if(!uploadInfo) return;
		var now = new Date().getTime();
		if (!uploadInfo.history) uploadInfo.history = new Array();
		//calculate speeds using a rolling 10 interval window.  This provides a smoother speed calculation that doesn't bounce around so much to make the user concerned
		var history = uploadInfo.history;//Progressbar data history
		var currentSpeed = uploadInfo.currentSpeed;//Current upload/download speed
		var speedHistory = uploadInfo.speedHistory || [];
		history.push({
			now: now,
			bytes: uploadInfo.part1
		});
		if (history.length > 1 && elem.hasClass("paused") == false) {//Calculation and updating progressbar. Calculation of speed, percentages etc.
			var pivot = 0; //If history is for less than 5 seconds, use data of first second
			if (history.length > 5) {
				pivot = history.length - 5; // Set pivot to be of previous five second
			}
			var elapsed = now - history[0].now; // Time elapsed
			var bytes = uploadInfo.part1 - history[pivot].bytes; // Bytes transferred in timeframe
			var lastElapsed = now - history[pivot].now;// Elapsed time for last transfer timeframe
			var originalBytes = uploadInfo.part1 - history[0].bytes; // total bytes transferred
			var secs = ((((uploadInfo.part2 - uploadInfo.part1) / (originalBytes / elapsed)) / 1000) + 1) + ""; // total time remaining
			var remaining = $.CrushFTP.formatTime(secs);//formatted time
			var percentDone = (uploadInfo.part1 / uploadInfo.part2) * 100.0;// percentages completed
			var rElapsed = $.CrushFTP.formatTime((elapsed / 1000) + 1 + "");// elapsed time formatted
			var speed = "";
			var currentActualSpeed = 0;
			if ((originalBytes / elapsed) == 0) {// Still Calculating
				speed = getLocalizationKeyExternal("BrowserUploaderSpeedTimeCalculatingText");
				remaining = getLocalizationKeyExternal("BrowserUploaderSpeedTimeCalculatingText");
				uploadInfo.currentSpeed = speed;
			} else {
				currentActualSpeed = (bytes / lastElapsed) * 1024.0;
				speed = $.CrushFTP.formatBytes(currentActualSpeed) + "/s";// Based on data transferred in last timeframe (5 secs)
				uploadInfo.currentSpeed = speed;
			}
			var uploadedSize = $.CrushFTP.formatBytes(uploadInfo.part1);
			var originalSize = $.CrushFTP.formatBytes(uploadInfo.part2);
			uploadInfo.originalSize = originalSize;
			var uploadStatusLabel = uploadedSize + ' of ' + originalSize;
			var timeStampLabel = getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingTimeText");
			timeStampLabel = timeStampLabel.replace("{0}", rElapsed);
			timeStampLabel = timeStampLabel.replace("{1}", remaining);
			var speedInfo = "";
			if(elapsed/1000 >= 20)
			{
				speedHistory.push(currentActualSpeed);
				uploadInfo.speedHistory = speedHistory;
				var getAverageSpeed = function()
				{
					if(speedHistory.length>30)
					{
						while (speedHistory.length > 30) speedHistory.shift();
					}
					var avgSpeed = speedHistory.average();
					if(avgSpeed>0)
					{
						return getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingAverageSpeedText") + $.CrushFTP.formatBytes(avgSpeed) + "/s , ";
					}
					else
						return "";
				}
				speedInfo = $("<div class='speed'>" + getAverageSpeed() + getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingSpeedText") + speed + "</div>");
			}
			else
			{
				speedInfo = $("<div class='speed'>" + getLocalizationKeyExternal("BrowserUploaderAdvancedUploadingSpeedText") + speed + "</div>");
			}

			//Global Progressbar
			globalProgressBar.show();
			var curFileIndex = curFile || elem.index() + 1;
			totalFiles = totalFiles || fileRepo.find("li.formProcessed").length;
			var fileName = unescape(elem.attr("fileName"));
			if(fileName.length>50)
				fileName = fileName.substr(0, 30) + "..." + fileName.substr(fileName.length-15, fileName.length);
			globalProgressBar.find(".time,.speed").remove();
			globalProgressBar.find(".progressbarMain").progressbar({"value" : percentDone}).end()
			.find(".progressBarText").text(uploadStatusLabel).end()
			.find(".uploadInfo").html("Uploading : <strong>" + fileName + "</strong>, " + curFileIndex + " of " + " total " + totalFiles + " file(s)")
			.after(speedInfo).after(timeStampLabel);

			if(elem.hasClass("appletItem"))
				globalProgressBar.find("a.pause").show();
			else
				globalProgressBar.find("a.pause").hide();

			globalProgressBar.find("a.pause").unbind().click(function(){
				elem.find("a.pause").trigger("click");
				return false;
			});

			globalProgressBar.find("a.skip").unbind().click(function(){
				elem.find("a.cancelUpload").trigger("click");
				return false;
			});

			globalProgressBar.find("a.stop").unbind().click(function(){
				fileRepo.find("a.cancelUploading").trigger("click");
				return false;
			});
		}
	}

	$.CrushFTP.removeGlobalProgressInfo = function(dontHide)
	{
		$.CrushFTP.UploadProgressing = false;
		$.CrushFTP.uploadAllQueued = false;
		if(!dontHide)
			globalProgressBar.fadeOut();
		globalProgressBar.removeData("uploadInfo");
		globalProgressBar.removeData("curFile");
		globalProgressBar.removeData("curFileSize");
		globalProgressBar.removeData("curFileCount");
	}

	$.CrushFTP.DNDUploadCallback = function(status, data, button, template){
		if(status == "completed")
		{
			var result = data.result
			button = template.find("a.startUpload");
			if(result && result.responseText)
			{
				var response = result.responseText;
				response = $(response).find("response").text();
				if (response.toLowerCase() != "success")
	            {
	                template.addClass("ui-state-error").removeClass("uploadProgress");
	                template.append("<span class='error'>"+response+"</span>");
	            }
				else
					template.removeClass("ui-state-error uploadProgress").effect("highlight", {}, 2000);
				button.addClass("uploaded");
			}
			else {
				template.removeClass("uploadProgress").addClass("ui-state-error").append("<span class='error'>File upload failed, please try again.</span>");
				button.addClass("uploaded");
			}
		}
		else if(status == "uploading")
		{
			$.CrushFTP.UploadProgressing = true;
			template.addClass("uploadProgress").find(".error, .uploadStatus").remove();
			$.CrushFTP.refreshProgressInfo(template);
			var startBtn = template.find("a.startUpload").hide();
			template.find("a.editForm").parent().hide();
			if(template.hasClass("appletItem"))
			{
				template.find("a.pause").parent().show();
			}
			template.find("div.progressInfo").show();
		}
		else if(status == "skipped")
		{
			template.removeClass("uploadProgress curQueue").addClass("skipped").find("a.startUpload").text(locale.fileupload.reupload).show();
			if(template.data("formData"))
				template.find("a.editForm").parent().show();
			template.find("a.pause").parent().hide();
			template.find("div.progressInfo").hide();
			if($.CrushFTP.uploadAllQueued)
			{
				var btn = $.CrushFTP.getNextQueuedItem();
				if(btn)
				{
					$.CrushFTP.UploadProgressing = false;
					btn.trigger("click", [{allInQueue:true}]);
				}
				else
				{
					$.CrushFTP.removeGlobalProgressInfo(true);
				}
			}
			else
			{
				$.CrushFTP.removeGlobalProgressInfo(true);
			}

			if(fileRepo.find("li.uploaded").length>0)
				clearUploadedAll.show();
			else
				clearUploadedAll.hide();
		}
		else if(status == "paused")
		{
			$.CrushFTP.UploadProgressing = true;
			//template.removeClass("uploadProgress");
			template.find("div.progressInfo").find("div.time, div.speed").remove().end().append("<div class='status'>"+getLocalizationKeyExternal("BrowserUploaderSelectedFilePausedStatusText")+"</div>");
		}
	}

	$.CrushFTP.getUploadProgress = function(callBack, elem, applet){
		var curData = $(elem).data("uploadInfo");
		if(!curData)
			curData = {part1 : 0, part2 : 0, status : "", history : new Array()};
		if(applet)
		{
			if(elem.attr("status") == "paused")
			{
				return "paused";
			}
			var result = runAppletCommand(true, "COMMAND=ACTION:::TYPE=UPLOAD:::ACTION=STATUS");
			var o = parseJavaProps(result);
			o.isApplet = true;
			if(typeof o.status == "string" && o.status.length == 0)
			{
				o.status = " ";
			}
			if (!o || !o.status || o.status.toUpperCase().indexOf("CANCELLED:") == 0)
			{
				//If file upload/download is cancelled
				o.status= "cancelled";
			}
			else
			{
				o.part1 = o.transferedBytes * 1;
				o.part2 = o.totalBytes * 1;
			}
			if (o.part1 < o.part2)
			{
				o.statusApplet = "uploading";
			}
			else {
				if (status && status.indexOf("ERROR") >= 0) {
					//If error while upload/download
					o.statusApplet = "error";
				} else {
					//If file upload/download completed
					o.statusApplet = "completed";
				}
			}
			curData = $.extend(curData, o);
			$(elem).data("uploadInfo", curData);
			callBack(curData);
		}
		else
		{
			var fileName = $(elem).attr("uid");
			$.ajax({
				type: "POST",
				url: $.CrushFTP.Options.ajaxCallURL,
				data: "command=getUploadStatus&itemName=" + encodeURIComponent(fileName),
				success: function (response) {
					var responseData = response;
					if (responseData == null) responseData = "";
					responseData = $.CrushFTP.getActionResponseText(responseData);
					responseData = jQuery.trim(responseData.toString());
					var o = {};
					o.status = "uploading";
					if (responseData.indexOf("PROGRESS:") >= 0) {
						var part1 = curData.part1 = responseData.substring("PROGRESS:".length, responseData.indexOf("/"));
						var part2 = curData.part2 = responseData.substring(responseData.indexOf("/") + 1, responseData.indexOf(";"));
						part1 = part1 * 1;
						part2 = part2 * 1;
						o.part1 = part1;
						o.part2 = part2;
					} else if (responseData.indexOf("DONE:") >= 0) {
						o.status = "completed";
					} else if (responseData == "null" || responseData == "") { //too quick, upload hasn't started up yet.
						o.status = "starting";
					} else if (responseData.indexOf("ERROR:") >= 0) {
						o.status = "error";
					} else {
						o.status = "error";
						o.message = responseData;
					}
					curData = $.extend(curData, o);
					$(elem).data("uploadInfo", curData);
					callBack(curData);
				},
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					o.status = "error";
					o.message = getLocalizationKeyExternal("BrowserUploaderProblemWhileTransferMsgText");
					curData = $.extend(curData, o);
					$(elem).data("uploadInfo", curData);
					callBack(curData);
					callBack(o);
				}
			});
		}
	}

	$("#hideFileQueue").click(function(){
		$("#droppedFiles").hide();
		return false;
	});
});