/*!
* CrushFTP VFS Browse Popup
*
* http://crushFTP.com/
*
* Copyright 2012, CrushFTP
*
* Date: Wed, Feb 29 2012
*
* Author: Vipul Limbachiya
*
* http://vipullimbachiya.com
*/

(function($){
    $.crushFtpVFSBrowserPopup = function(el, options){
        // To avoid scope issues, use 'base' instead of 'this'
        // to reference this class from internal events and functions.
        var base = this;

        // Access to jQuery and DOM versions of element
        base.$el = $(el);
        base.el = el;

        // Add a reverse reference to the DOM object
        base.$el.data("crushFtpVFSBrowserPopup", base);

        base.init = function(){
            base.options = $.extend({},$.crushFtpVFSBrowserPopup.defaultOptions, options);
            //initialization code here
			base.initVFSBrowse(base.options);
        };

        base.initVFSBrowse = function(options)
		{
			var serverDirBrowsePanelPopup = $("#serverDirBrowsePanelPopup");
			if(serverDirBrowsePanelPopup.length==0)
			{
				var htmlToAppend = "<div id=\"serverDirBrowsePanelPopup\">";
				htmlToAppend += "<table style=\"width:100%;\">";
				htmlToAppend += "	<tr>";
				htmlToAppend += "		<td style=\"vertical-align: top;\">";
				htmlToAppend += "			<select id=\"serverDirSelectListPopup\" style=\"width: 250px;\">";
				htmlToAppend += "			</select>";
				htmlToAppend += "			<br />";
				htmlToAppend += "			<div class=\"LargeListBox ui-corner-all ui-widget-content nobg sideScroll\" style=\"width:315px;height:365px;\">";
				htmlToAppend += "				<ol class=\"nobg selectable multiple sideScroll\" id=\"serverDirListingPanelPopup\" name=\"serverDirListingPanelPopup\">";
				htmlToAppend += "				</ol>";
				htmlToAppend += "			</div>";
				htmlToAppend += "		</td>";
				htmlToAppend += "	</tr>";
				htmlToAppend += "</table>";
				htmlToAppend += "</div>";
				$("body").append(htmlToAppend);
				serverDirBrowsePanelPopup = $("#serverDirBrowsePanelPopup").hide();
				var serverDirSelectList = $("#serverDirSelectListPopup", serverDirBrowsePanelPopup);
				base.dirSelectEventActive(true);
			}
			serverDirBrowsePanelPopup.find(".note").remove();
			if(options.note)
			{
				serverDirBrowsePanelPopup.find("#dirList").after("<div class='note' style='margin-top:10px;'>"+ options.note +"</div>");
			}
			serverDirBrowsePanelPopup.dialog({
				autoOpen: false,
				title : "Select Path",
				height: 520,
				width: 350,
				modal: true,
				resizable: true,
				closeOnEscape: false,
				buttons: {
					"Cancel" : function(){
						$(this).dialog( "close" );
					},
					"Ok": function() {
						var selected = $("#serverDirListingPanelPopup").find("li.ui-selected");
						if(selected.length>0)
						{
							if(options.callback)
							{
								options.callback(unescape(selected.attr("hrefpath")));
							}
							$(this).dialog( "close" );
						}
						else
						{
							return false;
						}
					}
				},
				beforeClose : function(){
					return true;
				},
				open : function(){
					base.browseVFSItem();
				}
			});
			$("#serverDirSelectListPopup").empty().append("<option>/</option>");
			serverDirBrowsePanelPopup.attr("pickType", options.type);
			serverDirBrowsePanelPopup.dialog("open");
		};

		base.dirSelectEventActive = function(flag)
		{
			var serverDirSelectList = $("#serverDirSelectListPopup");
			serverDirSelectList.unbind();
			if(flag)
			{
				serverDirSelectList.change(function(){
					$(this).find("option:selected").nextAll("option").remove();
					base.browseVFSItem(unescape($(this).val()), true);
					return false;
				});
			}
		}

		base.browseVFSItem = function(curDir, fromDD)
		{
			var serverDirBrowsePanelPopup = $("#serverDirBrowsePanelPopup").block({
				message:  '<div><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-refresh"></span>Please wait..</div>',
				css: {
					border: 'none',
					padding: '15px',
					backgroundColor: '#000',
					'-webkit-border-radius': '10px',
					'-moz-border-radius': '10px',
					opacity: .5,
					color: '#fff',
					width: '100px',
					'text-align':'left'
				}
			});
			curDir = curDir || "/";
			var ajaxCallURL = "/WebInterface/function/";
			var serverDirSelectList = $("#serverDirSelectListPopup");
			if(curDir != "/" && !fromDD)
			{
				if(unescape(serverDirSelectList.val()) != "/")
					curDir = unescape(serverDirSelectList.val()) + "/" + curDir;
				else if(curDir.indexOf("/")<0)
					curDir = "/" + curDir;
			}
			if(curDir.lastIndexOf("/")!=curDir.length-1)
			{
				curDir = curDir + "/";
			}
			curDir = curDir.replace("\\/", "");
			curDir = curDir.replace("//", "/");
			var obj = {
				command: "getAdminXMLListing",
				format: "JSON",
				path: encodeURIComponent(unescape(unescape(curDir))),
				random: Math.random()
			};
			/* Make a call and receive list */
			var itemsPanel = $("#serverDirListingPanelPopup");
			$.ajax({
				type: "POST",
				url: ajaxCallURL,
				data: obj,
				success: function (msg){
					if (msg && msg.childNodes && msg.childNodes.length > 0) {
						var items = $(msg).find("listing").text();
						if(items)
						{
							items = items.replace(/\n/g,' ').replace(/\s/g,' ');
							eval(items);
							if(l && jQuery.isArray(l))
							{
								itemsPanel.empty();
								for(var i=0; i<=l.length;i++)
								{
									var curItem = l[i];
									if(curItem && unescape(curItem.name).length>0 && curItem.type)
									{
										var name = unescape(curItem.name.toString());
										if(name.indexOf(".")!=0)
										{
											var hrefPath = "";
											if(curItem.href_path)
											{
												hrefPath = unescape(curItem.href_path);
												if(curItem.type.toLowerCase() == "dir" && hrefPath.lastIndexOf("/") != hrefPath.length-1)
												{
													hrefPath = hrefPath + "/";
												}
											}
											itemsPanel.append("<li style='padding:5px 10px;' hrefPath='"+escape(hrefPath)+"' name='"+unescape(curItem.name)+"' path='"+unescape(curItem.name)+"' privs='"+curItem.privs+"' _type='"+curItem.type.toLowerCase()+"'>"+name+"</li>");
										}
									}
									else if(curItem && unescape(curItem.href_path).length>0 && curItem.type)
									{
										var name = unescape(curItem.href_path);
										name = name.substr(name.lastIndexOf("/") + 1, name.length-1);
										if(name.length==0)
										{
											name = unescape(curItem.href_path);
											name = name.substr(0, name.lastIndexOf("/"));
										}
										if(name.indexOf(".")!=0)
										{
											itemsPanel.append("<li style='padding:5px 10px;' name='"+unescape(curItem.name)+"' path='"+name+"' privs='"+curItem.privs+"' _type='"+curItem.type.toLowerCase()+"'>"+name+"</li>");
										}
									}
								}

								if(curDir != "/")
								{
									if(serverDirSelectList.find("option[value='"+escape(curDir)+"']").attr("selected", "selected").length==0)
									{
										base.dirSelectEventActive(false);
										serverDirSelectList.append("<option selected value='"+escape(curDir)+"'>"+curDir+"</option>");
										base.dirSelectEventActive(true);
									}
									itemsPanel.prepend("<li style='padding:5px 10px;' curLevel=\""+curDir+"\" class='uplevelLink' upLevel=\"true\">..</li>");
								}
								if(itemsPanel.find("li:first").length>0)
									itemsPanel.parent().scrollTo(itemsPanel.find("li:first"));

								base.formatDirListingItems(itemsPanel);

								setTimeout(function(){
									// Remove selection range, it messes up UI as all the text came between selection highlights in native browser selection manner
									if (window.getSelection) // Modern Browsers
									{
										var selection = window.getSelection();
										if (selection.removeAllRanges) {
											selection.removeAllRanges();
										}
									}
									if (document.getSelection) // IE
									{
										var selection = document.getSelection();
										if (selection.removeAllRanges) {
											selection.removeAllRanges();
										}
									}
								}, 100);

								serverDirBrowsePanelPopup.unblock();
							}
						}
					}
				},
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					serverDirBrowsePanelPopup.unblock();
					errorThrown = errorThrown || "getUserXMLListing failed";
					alert("Error : " + errorThrown);
					return false;
				}
			});
		};

		base.formatDirListingItems = function(list)
		{
			var serverDirBrowsePanel = $("#serverDirListingPanelPopup");
			list.find("li").each(function(){
				var fileName = $(this).text();
				if(fileName.indexOf("/") == 0)
				{
					fileName = fileName.substr(1, fileName.length-1);
					$(this).text(fileName);
				}
				$(this).find("span.ui-icon").remove();
				$(this).prepend('<span style="display: inline-block; margin: 0px 3px 0px -7px;float: left;" class="pointer ui-icon"></span>');
				if($(this).attr("upLevel"))
				{
					$(this).find("span.ui-icon").addClass("ui-icon-arrowreturnthick-1-n");
				}
				else if($(this).attr("_type").toLowerCase()== "dir")
				{
					$(this).find("span.ui-icon").addClass("ui-icon-folder-collapsed");
				}
				else
				{
					$(this).find("span.ui-icon").addClass("ui-icon-document");
				}
			}).addClass("wrapword");

			list.selectableAdvanced("destroy");

			list.selectableAdvanced({
				change: function(event, ui) {
					var selected = $(ui.selection);
					selected.parent().find(".ui-selected, .ui-state-focus").removeClass("ui-selected ui-state-active ui-state-focus");
					selected.filter(":last").addClass("ui-selected ui-state-active");
					if(selected.is("li"))
					{
						try{
							var events = $(this).data('events');
							if(events && events.onSelect)
							{
								$(this).trigger("onSelect", [$(this), selected]);
							}
						}
						catch(ex){
							if(ex && ex.toString() != "")
							{
								userManager.UI.growl("Error", ex, true);
							}
						}
					}
					return false;
				},
				onEnter : function()
				{
					list.find("li.ui-selected:last").trigger("dblclick");
				},
				callOnSelection : function(itemLi)
				{
					/*var parentDiv = itemLi.closest("div")
					parentDiv.scrollTop(parentDiv.scrollTop() + itemLi.position().top - parentDiv.height()/2 + itemLi.height()/2);*/
					return false;
				}
			});

			list.unbind("onSelect").bind("onSelect"
				, function(evt, list, selected){
					if($(selected).is(".uplevelLink"))
					{
						evt.stopPropagation();
						evt.preventDefault();
						base.serverDirSelected($(selected), true);
					}
					else
					{
						base.vfsItemSelected(list, selected);
					}
					base.makeSelection(selected);
				return false;
			});

			list.find("li").unbind().bind("dblclick", function(){
				base.serverDirSelected($(this), true);
				return false;
			});
			base.makeSelection();
		};

		base.makeSelection = function(selected)
		{
			var serverDirBrowsePanelPopup = $("#serverDirBrowsePanelPopup");
			var pickupType = serverDirBrowsePanelPopup.attr("pickType");
			var btn = serverDirBrowsePanelPopup.parent(".ui-dialog").find("button:last");
			btn.attr("disabled", "disabled").addClass("ui-state-disabled")
			if(!selected)return;
			if(pickupType == "dir" && selected.attr("_type") == "dir")
			{
				btn.removeAttr("disabled").removeClass("ui-state-disabled");
			}
			else if(pickupType == "file" && selected.attr("_type") != "dir")
			{
				btn.removeAttr("disabled").removeClass("ui-state-disabled");
			}
			else if(pickupType == "both" || pickupType == "any")
			{
				btn.removeAttr("disabled").removeClass("ui-state-disabled");
			}
		};

		base.serverDirSelected = function(selected)
		{
			if(selected)
			{
				var goToDir = selected.attr("path");
				if(selected.attr("upLevel"))
				{
					var curDir = selected.attr("curLevel");
					if(curDir.lastIndexOf("/")==curDir.length-1)
					{
						curDir = curDir.substr(0, curDir.lastIndexOf("/"));
					}
					goToDir = curDir.substr(0, curDir.lastIndexOf("/"));
					if(goToDir.length == 0) goToDir = false;
					var dirDropDown = $("#serverDirSelectListPopup");
					base.dirSelectEventActive(false);
					dirDropDown.find("option[value='"+escape(selected.attr("curLevel"))+"']").nextAll("option").remove();
					dirDropDown.find("option[value='"+escape(selected.attr("curLevel"))+"']").remove();
					base.browseVFSItem(goToDir);
					base.dirSelectEventActive(true);
				}
				else if(selected.attr("_type") == "dir")
				{
					base.browseVFSItem(goToDir);
				}
			}
		};

		base.vfsItemSelected = function()
		{

		}
        // Run initializer
        base.init();
    };
    $.crushFtpVFSBrowserPopup.defaultOptions = {
		type : 'dir'
    };

    $.fn.crushFtpVFSBrowserPopup = function(options){
        return this.each(function(){
            (new $.crushFtpVFSBrowserPopup(this, options));
        });
    };

})(jQuery);